<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>Workflow Editor Graphical User Interface</title>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="http://purl.org/dc/elements/1.1/" rel="schema.DC" />
<meta content="Martin Haase / DAASI International" name="DC.creator" />
<meta content="2009-07-22T16:29:08.37" name="DC.date" />
<link rel="stylesheet" href="../help.css" charset="utf-8"
	type="text/css" />
</head>

<body>
<h1 id="toc0">Workflow Editor Graphical User Interface</h1>
<P>The Workflow <B>GUI</B> is implemented as an Eclipse perspective,
consisting of an editor area (for editing the <I>tgwf</I> workflow
document or input/result objects) and the following views:</P>
<UL>
	<LI><P>Workflow preparation: here you can select a <I>tgwf</I>
	Workflow document, display input TexGridObjects, choose the target
	project where resulting objects are to be created, and initiate the
	execution of the workflow</P></LI>
	<LI><P>Job Management: query for the status of the user's wokflow
	jobs at the engine</P></LI>
	<LI><P>Result viewer: display the list of resulting TextGridObjects
	created anew</P></LI>
</UL>
<P>The following figure 4 shows the interface; more details on how
to use the GUI will be explained below.</P>
<P><IMG SRC="Bildschirmfoto-TextGridLab-Workflow.png" NAME="Grafik5" ALIGN="BOTTOM" WIDTH="100%" HEIGHT="100%" BORDER="0"/></P>
<P>figure 4: The workflow perspective</P>
<H3>Opening the Workflow GUI</H3>
<P>The workflow perspective can be opened in different ways:</P>
<OL>
	<LI><P>By clicking on the “Workflow” link/icon on the welcome
	screen</P></LI>
	<LI><P>By selecting “Workflow” from the “Tools” menu</P></LI>
	<LI><P>B clicking the 
	<IMG SRC="Workflow.gif" NAME="Grafik3" ALIGN="BOTTOM" WIDTH="28" HEIGHT="16" BORDER="0"/>
	icon in the icon tray</P></LI>
	<LI><P>or, by right-clicking on one or more TextGridObjects in
	either the Research Results or the Navigator, and choosing “Add to
	Workflow” (see figure 5 below)</P></LI>
</OL>
<P><IMG SRC="addToWorkflow.png" NAME="Grafik4" ALIGN="BOTTOM" WIDTH="50%" HEIGHT="50%" BORDER="0"/></P>
<P>figure 5: Adding input documents to a workflow</P>
<P>The first three options will be more useful if a user wants to
<I>query</I> the status of her workflows, or if she just wants to
jump to this <I>perspective</I>, or reset it. If on the other hand
the user wants to <I>execute </I>an existing workflow with some input
objects, the fourth option should be chosen.</P>
<H3>Workflow Preparation</H3>
<P>This is the left-hand side view of the workflow perspective. It
contains: 
</P>
<UL>
	<LI><P>A list of all available workflow. If the user is not logged
	in, only published workflows will appear here. In order to see your
	own ones, press the “Refresh list” button after logging in. Do
	this also if you just created a new workflow. It is possible to
	view, and, depending on your rights, edit the workflows by
	right-clicking in this list and choosing an appropriate editor.</P></LI>
	<LI><P>The selection of the target project into which the newly
	created TextGridObjects (the result of processing your input
	TextGridObjects) are to be saved. You must be logged in for the TextGridLab
	to know your status (e.g. <i>Bearbeiter</i>) on any project.
	<!--You need to be logged in, such
	that the TextGridLab knows in which projects you have <I>create</I>
	permission (i.e. where you own the role <I>Bearbeiter </I>given the
	standard role assignment is active).--></P></LI>
	<LI><P>A list of the input documents scheduled for your workflow.
	Add new documents to the list by right-clicking on one or more
	TextGridObjects in either the Research Results or the Navigator, and
	choosing “Add to Workflow”. Remove them from the list by
	selecting one or more entries and clicking the “Remove selected
	input(s)” button. It is possible to view, and, depending on your
	rights, edit the input documents by right-clicking in this list and
	choosing an appropriate editor.</P></LI>
	<LI><P>And finally, the button “Run with input document”, which
	will execute the workflow selected in the upper list, with the input
	documents from the lower list. The resulting documents will be
	stored in the project specified as the target project. 
	</P></LI>
</UL>
<P>Once the workflow is started by the “Run...” button, it will
be submitted to the GWES workflow engine and started there. It will
be added to the Job Management view as “active”.</P>
<H3>Job Management</H3>
<P>All jobs owned by the current user will be displayed in this list.
If you expect to see some jobs here, check to see if you are not
logged in yet. Every job is listed by its name, its time of
submission, and its status. The status of the job can be one of:</P>
<UL>
	<LI><P>initiated – the workflow has just been submitted but not
	started yet</P></LI>
	<LI><P>running – state when the workflow has been started</P></LI>
	<LI><P>active – if there are active transitions working</P></LI>
	<LI><P>suspended – if a user (perhaps via the monitoring tool)
	paused the workflow</P></LI>
	<LI><P>completed – if the workflow ended successful</P></LI>
	<LI><P>terminated – if there was an error during execution</P></LI>
</UL>
<P>There are two buttons below the list: The “Refresh job list”
button queries for the current status of the user's workflows at the
workflow engine. The “See results” button has two meanings:</P>
<UL>
	<LI><P>either, if the status of the selected job is <I>completed</I>,
	it will display the result documents of this job in the Workflow
	Results window.</P></LI>
	<LI><P>or, if the status of the selected job is <I>terminated</I>,
	it will show an error message to the user and write the engine's
	error or warning output into the TextGridLab's error log file.</P></LI>
</UL>
<H3>Workflow Results</H3>
<P>This list is for the user's convenience. Instead of having to
locate the resulting documents in the Navigator, or searching for
them, all resulting TextGridObjects created as the output of the
respective Workflow will be displayed here. It is possible to view,
and edit these documents by right-clicking in this list and choosing
an appropriate editor. Currently the user still has to select the
workflow in the Job Management view and click “See results” first
before they are displayed.</P>
<H3>Writing a new Workflow from Scratch</H3>
<P>A new TextGrid workflow is created similarly to any other
TextGridObject: Choose “New Object...” from the File menu, then
pick the project to save this workflow in, and select “TextGrid
Workflow Document” as type of the new object. The next step is to
enter the metadata of the workflow, which is not different compared
to other TextGridObjects – however, it is better to accept the
pre-set type “workflow” here in order to search more easily later
on.</P>
<P>After clicking on “Finish”, the TextGrid XML Editor will be
opened with a template of an incomplete workflow. Use either the
“Design” or the “Source” view. The editor knows the <I>tgwf</I>
schema behind the workflow and will assist you with typing in. You
may want to adapt contents of already existing workflows to your
needs. If you are unsure about editing the <I>tgwf</I> XML or the XSL
stylesheet contained therein (the rules for creating the new metadata
of the resulting objects), please feel free to ask for support from
the TextGrid community.</P>
</body>
</html>